require './lib/redpay/session'

require 'json'
require 'ostruct'

class TokenizeCard

  def initialize(app, key, endpoint)
    @app      = app
    @key      = key
    @endpoint = endpoint
  end
  
  def Process(request)
    json_request = JSON.parse(request.to_json, object_class: OpenStruct)
    # TODO Validate request here

    # Create a session with the server
    session = Session.new(@app, @key, @endpoint + "token")

    # Contruct tokenize card packet
    req = 
    {
      "account" => json_request.account,
      "action" => "T",
      "expmmyyyy" => json_request.expmmyyyy,
      "cvv" => json_request.cvv,
      "cardHolderName" => json_request.accountHolder,
      "avsZip" => json_request.zipCode,
      "currency" => json_request.currency ||= "USD",
    }

    return session.Send(req)
  end
  
end